﻿using UnityEngine;
using System.Collections;

public class player : MonoBehaviour {

    int cooldown1;
    int cooldown2;
    int cooldown3;
    public int health;
    public int lives;
    public bool dead;
    Animator anim;
    private SpriteRenderer spr;
    public bool faceingLeft;
    public TextMesh scoreText;
    public bool hasFlag;
    public int time;
    float timerStart;
    public static int countdown;
    public float speed;
    public float maxSpeed;
    public float jumpForce;
    Rigidbody2D rb;
    public bool grounded;
    Collider2D col;

    private string shootkey = "Fire1";
    private string usekey = "Fire2";
    private string bombkey = "Fire3";

    private string playerkey = "";

    private GameObject[] respawns;


	// Use this for initialization
	void Start ()
    {
        cooldown1 = 0;
        cooldown2 = 0;
        cooldown3 = 0;
        dead = false;
        anim = GetComponent<Animator>();
        spr = GetComponent<SpriteRenderer>();
        scoreText = GetComponentInParent<TextMesh>();
        hasFlag = false;
        time = 0;
        countdown = 0;
        rb = GetComponent<Rigidbody2D>();
        // grounded = true;
        col = GetComponent<BoxCollider2D>();

        if (tag == "Player2")
        {
            playerkey = "_P2";
        }

        respawns = GameObject.FindGameObjectsWithTag("Respawn");
	}

    // Update is called once per frame
    void Update()
    {
        cooldown1--;
        cooldown2--;
        cooldown3--;
        if (dead)
        {
            transform.position = new Vector3(-10, -10);
        }
        else {


            anim.SetBool("faceingLeft", faceingLeft);
            if (faceingLeft)
            {
                spr.flipX = false;
            }
            else
            {
                spr.flipX = true;
            }

            anim.SetBool("Walk", false);


            countdown--;
            if (transform.childCount == 3)
            {
                hasFlag = true;
            }
            else
            {
                hasFlag = false;
            }
            if (hasFlag)
            {
                if (Time.time - timerStart >= 1.0f)
                {
                    timerStart++;
                    if (transform.tag == ("Player" + 1))
                    {
                        pointHolder.p1Flag++;
                        scoreText.text = ("" + pointHolder.p1Flag);
                    }
                    if (transform.tag == ("Player" + 2))
                    {
                        pointHolder.p2Flag++;
                        scoreText.text = ("" + pointHolder.p2Flag);
                    }
                    if (transform.tag == ("Player" + 3))
                    {
                        pointHolder.p3Flag++;
                        scoreText.text = ("P3: " + pointHolder.p3Flag);
                    }
                    if (transform.tag == ("Player" + 4))
                    {
                        pointHolder.p4Flag++;
                        scoreText.text = ("P4: " + pointHolder.p4Flag);
                    }
                }
            }
            else
            {
                timerStart = Time.time;
            }
            //Vector3 movement = new Vector3(moveHorizontal, 0.0f, moveVertical);
            //rb.velocity = movement * speed;
            if (CannonAim.activeController == this.gameObject)
            {
                rb.isKinematic = true;
                col.isTrigger = true;
                this.transform.position = new Vector3(this.transform.position.x, this.transform.position.y, 0.4f);
                if (Input.GetAxis(usekey + playerkey) == 1 && countdown < 0)
                {
                    countdown = 30;
                    CannonAim.active = false;
                    CannonAim.activeController = null;
                    this.transform.position = new Vector3(this.transform.position.x, this.transform.position.y, 0.1f);
                }
            }
            else
            {
                col.isTrigger = false;
                rb.isKinematic = false;
            }
            if (transform.position.y < -10)
            {
                lives--;

                int i = Random.Range(0, respawns.Length - 1);
                transform.position = respawns[i].transform.position;

                rb.velocity = new Vector2(0, 0);
                if (lives <= 0)
                {
                    dead = true;
                }

                if (hasFlag)
                {
                    //transform.FindChild("flag").parent = null;
                    transform.FindChild("flag").parent = GameObject.FindGameObjectWithTag("flag").GetComponent<Flag>().initialParent;
                    GameObject.FindGameObjectWithTag("flag").transform.position = new Vector3(0, 0, 0);
                    hasFlag = false;
                }
            }
            if (health <= 0)
            {
                lives--;

                int i = Random.Range(0, respawns.Length - 1);
                transform.position = respawns[i].transform.position;

                rb.velocity = new Vector2(0,0);
                health = 5;
                if (lives <= 0)
                {
                    dead = true;
                }

                if (hasFlag)
                {
                    //transform.FindChild("flag").parent = null;
                    transform.FindChild("flag").parent = GameObject.FindGameObjectWithTag("flag").GetComponent<Flag>().initialParent;
                    GameObject.FindGameObjectWithTag("flag").transform.position = new Vector3(0, 0, 0);
                    hasFlag = false;
                }
            }

            if (CannonAim.activeController != this.gameObject)
            {
                if (Input.GetAxis(shootkey + playerkey) == 1)
                {
                    if (hasFlag)
                    {
                        //transform.FindChild("flag").parent = null;
                        transform.FindChild("flag").parent = GameObject.FindGameObjectWithTag("flag").GetComponent<Flag>().initialParent;
                        GameObject.FindGameObjectWithTag("flag").transform.position = new Vector3(0, 0, 0);
                        hasFlag = false;
                    }
                }

                if (Input.GetAxis("Jump" + playerkey) == 1 && grounded)
                {
                    rb.AddForce(Time.deltaTime * new Vector2(0.0f, jumpForce));
                    anim.SetTrigger("Jump");
                }
                if (Input.GetAxis("Horizontal" + playerkey) == -1)
                {
                    faceingLeft = true;
                    rb.AddForce(-Time.deltaTime * new Vector2(speed, 0.0f));
                    anim.SetBool("Walk", true);
                }
                else if (Input.GetAxis("Horizontal" + playerkey) == 1)
                {
                    faceingLeft = false;
                    rb.AddForce(Time.deltaTime * new Vector2(speed, 0.0f));
                    anim.SetBool("Walk", true);
                }
                else
                {
                    anim.SetBool("Walk", false);
                }
                if (rb.velocity.x < -maxSpeed)
                {
                    rb.velocity = new Vector2(-maxSpeed, rb.velocity.y);
                }
                if (rb.velocity.x > maxSpeed)
                {
                    rb.velocity = new Vector2(maxSpeed, rb.velocity.y);
                }
            }
        }
    }
    void OnTriggerStay2D(Collider2D col)
    {
        if (col.gameObject.tag == "CannonBall" && CannonAim.activeController != this.gameObject)
        {
            health = 0;
            Destroy(col.gameObject);
        }
        if (col.gameObject.tag == "explosion" && cooldown1 < 0)
        {
            cooldown1 = 30;
            health-=2;
            if (health < 0) health = 0;
            Destroy(col.gameObject);
        }
        if (col.gameObject.tag == "attack" && !col.GetComponentInParent<player>().hasFlag && cooldown2 < 0)
        {
            cooldown2 = 10;
            health--;
            //Destroy(col.gameObject);
        }
        if (col.gameObject.tag == "bullet" && cooldown3 < 0)
        {
            cooldown3 = 30;
            health--;
            Destroy(col.gameObject);
        }
    }
}
